diff --git a/vscode-extensions/vscode-boot-java/pom.xml b/vscode-extensions/vscode-boot-java/pom.xml
index 90e2573db..4457b0e29 100644
--- a/vscode-extensions/vscode-boot-java/pom.xml
+++ b/vscode-extensions/vscode-boot-java/pom.xml
@@ -44,14 +44,6 @@
${project.version}
-
-
- org.springframework.ide.vscode
- language-server-test-harness
- ${project.version}
- test
-
-
org.eclipse.jdt
@@ -65,6 +57,14 @@
2.4
+
+
+ org.springframework.ide.vscode
+ language-server-test-harness
+ ${project.version}
+ test
+
+
diff --git a/vscode-extensions/vscode-boot-java/src/main/java/org/springframework/ide/vscode/boot/java/completions/BootJavaCompletionEngine.java b/vscode-extensions/vscode-boot-java/src/main/java/org/springframework/ide/vscode/boot/java/completions/BootJavaCompletionEngine.java
index f151264fc..8d20b070c 100644
--- a/vscode-extensions/vscode-boot-java/src/main/java/org/springframework/ide/vscode/boot/java/completions/BootJavaCompletionEngine.java
+++ b/vscode-extensions/vscode-boot-java/src/main/java/org/springframework/ide/vscode/boot/java/completions/BootJavaCompletionEngine.java
@@ -111,7 +111,9 @@ public class BootJavaCompletionEngine implements ICompletionEngine {
IJavaProject project = this.projectFinder.find(doc);
IClasspath classpath = project.getClasspath();
Stream classpathEntries = classpath.getClasspathEntries();
- return classpathEntries.map(path -> path.toAbsolutePath().toString()).toArray(String[]::new);
+ return classpathEntries
+ .filter(path -> path.toFile().exists())
+ .map(path -> path.toAbsolutePath().toString()).toArray(String[]::new);
}
}
diff --git a/vscode-extensions/vscode-boot-java/src/main/java/org/springframework/ide/vscode/boot/java/completions/ScopeCompletionProcessor.java b/vscode-extensions/vscode-boot-java/src/main/java/org/springframework/ide/vscode/boot/java/completions/ScopeCompletionProcessor.java
index 350e94605..cea007c94 100644
--- a/vscode-extensions/vscode-boot-java/src/main/java/org/springframework/ide/vscode/boot/java/completions/ScopeCompletionProcessor.java
+++ b/vscode-extensions/vscode-boot-java/src/main/java/org/springframework/ide/vscode/boot/java/completions/ScopeCompletionProcessor.java
@@ -34,7 +34,7 @@ public class ScopeCompletionProcessor {
MemberValuePair memberPair = (MemberValuePair) node.getParent();
// case: @Scope(value=<*>)
- if (memberPair.getName() != null && memberPair.getValue().toString().equals("$missing$")) {
+ if ("value".equals(memberPair.getName().toString()) && memberPair.getValue().toString().equals("$missing$")) {
for (ScopeNameCompletion completion : ScopeNameCompletionProposal.COMPLETIONS) {
ICompletionProposal proposal = new ScopeNameCompletionProposal(completion, doc, offset, offset, "");
completions.add(proposal);
@@ -49,7 +49,7 @@ public class ScopeCompletionProcessor {
}
}
else if (node instanceof StringLiteral && node.getParent() instanceof Annotation) {
- // case: @Scope(value="")
+ // case: @Scope("...")
if (node.toString().startsWith("\"") && node.toString().endsWith("\"")) {
String prefix = doc.get(node.getStartPosition(), offset - node.getStartPosition());
for (ScopeNameCompletion completion : ScopeNameCompletionProposal.COMPLETIONS) {
@@ -60,6 +60,20 @@ public class ScopeCompletionProcessor {
}
}
}
+ else if (node instanceof StringLiteral && node.getParent() instanceof MemberValuePair) {
+ MemberValuePair memberPair = (MemberValuePair) node.getParent();
+
+ // case: @Scope(value=<*>)
+ if ("value".equals(memberPair.getName().toString()) && node.toString().startsWith("\"") && node.toString().endsWith("\"")) {
+ String prefix = doc.get(node.getStartPosition(), offset - node.getStartPosition());
+ for (ScopeNameCompletion completion : ScopeNameCompletionProposal.COMPLETIONS) {
+ if (completion.getValue().startsWith(prefix)) {
+ ICompletionProposal proposal = new ScopeNameCompletionProposal(completion, doc, node.getStartPosition(), node.getStartPosition() + node.getLength(), prefix);
+ completions.add(proposal);
+ }
+ }
+ }
+ }
}
catch (Exception e) {
e.printStackTrace();
diff --git a/vscode-extensions/vscode-boot-java/src/test/java/org/springframework/ide/vscode/boot/java/completions/test/ScopeCompletionTest.java b/vscode-extensions/vscode-boot-java/src/test/java/org/springframework/ide/vscode/boot/java/completions/test/ScopeCompletionTest.java
new file mode 100644
index 000000000..02f21e878
--- /dev/null
+++ b/vscode-extensions/vscode-boot-java/src/test/java/org/springframework/ide/vscode/boot/java/completions/test/ScopeCompletionTest.java
@@ -0,0 +1,178 @@
+/*******************************************************************************
+ * Copyright (c) 2017 Pivotal, Inc.
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ * Pivotal, Inc. - initial API and implementation
+ *******************************************************************************/
+package org.springframework.ide.vscode.boot.java.completions.test;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertTrue;
+
+import java.io.InputStream;
+import java.util.List;
+import java.util.concurrent.Callable;
+
+import org.apache.commons.io.IOUtils;
+import org.eclipse.lsp4j.CompletionItem;
+import org.junit.Before;
+import org.junit.Test;
+import org.springframework.ide.vscode.boot.java.BootJavaLanguageServer;
+import org.springframework.ide.vscode.commons.java.IJavaProject;
+import org.springframework.ide.vscode.commons.languageserver.java.JavaProjectFinder;
+import org.springframework.ide.vscode.languageserver.testharness.Editor;
+import org.springframework.ide.vscode.languageserver.testharness.LanguageServerHarness;
+import org.springframework.ide.vscode.project.harness.ProjectsHarness;
+
+/**
+ * @author Martin Lippert
+ */
+public class ScopeCompletionTest {
+
+ private final JavaProjectFinder javaProjectFinder = (doc) -> getTestProject();
+
+ private LanguageServerHarness harness;
+ private IJavaProject testProject;
+
+ private Editor editor;
+
+ @Before
+ public void setup() throws Exception {
+ testProject = ProjectsHarness.INSTANCE.mavenProject("test-scope-annotation");
+
+ harness = new LanguageServerHarness(new Callable() {
+ @Override
+ public BootJavaLanguageServer call() throws Exception {
+ BootJavaLanguageServer server = new BootJavaLanguageServer(javaProjectFinder);
+ return server;
+ }
+ }) {
+ @Override
+ protected String getFileExtension() {
+ return ".java";
+ }
+ };
+ harness.intialize(null);
+ }
+
+ private IJavaProject getTestProject() {
+ return testProject;
+ }
+
+ @Test
+ public void testEmptyBracketsCompletion() throws Exception {
+ prepareCase("@Scope(\"onClass\")", "@Scope(<*>)");
+ assertAnnotationCompletions(
+ "@Scope(\"prototype\"<*>)",
+ "@Scope(\"singleton\"<*>)",
+ "@Scope(\"request\"<*>)",
+ "@Scope(\"session\"<*>)",
+ "@Scope(\"globalSession\"<*>)",
+ "@Scope(\"application\"<*>)",
+ "@Scope(\"websocket\"<*>)");
+ }
+
+ @Test
+ public void testEmptyStringLiteralCompletion() throws Exception {
+ prepareCase("@Scope(\"onClass\")", "@Scope(\"<*>\")");
+ assertAnnotationCompletions(
+ "@Scope(\"prototype\"<*>)",
+ "@Scope(\"singleton\"<*>)",
+ "@Scope(\"request\"<*>)",
+ "@Scope(\"session\"<*>)",
+ "@Scope(\"globalSession\"<*>)",
+ "@Scope(\"application\"<*>)",
+ "@Scope(\"websocket\"<*>)");
+ }
+
+ @Test
+ public void testEmptyValueCompletion() throws Exception {
+ prepareCase("@Scope(\"onClass\")", "@Scope(value=<*>)");
+ assertAnnotationCompletions(
+ "@Scope(value=\"prototype\"<*>)",
+ "@Scope(value=\"singleton\"<*>)",
+ "@Scope(value=\"request\"<*>)",
+ "@Scope(value=\"session\"<*>)",
+ "@Scope(value=\"globalSession\"<*>)",
+ "@Scope(value=\"application\"<*>)",
+ "@Scope(value=\"websocket\"<*>)");
+ }
+
+ @Test
+ public void testEmptyValueStringLiteralCompletion() throws Exception {
+ prepareCase("@Scope(\"onClass\")", "@Scope(value=\"<*>\")");
+ assertAnnotationCompletions(
+ "@Scope(value=\"prototype\"<*>)",
+ "@Scope(value=\"singleton\"<*>)",
+ "@Scope(value=\"request\"<*>)",
+ "@Scope(value=\"session\"<*>)",
+ "@Scope(value=\"globalSession\"<*>)",
+ "@Scope(value=\"application\"<*>)",
+ "@Scope(value=\"websocket\"<*>)");
+ }
+
+ @Test
+ public void testPrefixWithClosingQuotesCompletion() throws Exception {
+ prepareCase("@Scope(\"onClass\")", "@Scope(\"pro<*>\")");
+ assertAnnotationCompletions(
+ "@Scope(\"prototype\"<*>)");
+ }
+
+ @Test
+ public void testPrefixWithoutClosingQuotesCompletion() throws Exception {
+ prepareCase("@Scope(\"onClass\")", "@Scope(\"pro<*>)");
+ assertAnnotationCompletions();
+ }
+
+ @Test
+ public void testValuePrefixWithClosingQuotesCompletion() throws Exception {
+ prepareCase("@Scope(\"onClass\")", "@Scope(value=\"pro<*>\")");
+ assertAnnotationCompletions(
+ "@Scope(value=\"prototype\"<*>)");
+ }
+
+ @Test
+ public void testValuePrefixWithoutClosingQuotesCompletion() throws Exception {
+ prepareCase("@Scope(\"onClass\")", "@Scope(value=\"pro<*>)");
+ assertAnnotationCompletions();
+ }
+
+ @Test
+ public void testPrefixReplaceRestCompletion() throws Exception {
+ prepareCase("@Scope(\"onClass\")", "@Scope(\"pro<*>something\")");
+ assertAnnotationCompletions(
+ "@Scope(\"prototype\"<*>)");
+ }
+
+ @Test
+ public void testDifferentMemberNameCompletion() throws Exception {
+ prepareCase("@Scope(\"onClass\")", "@Scope(proxyName=\"<*>\")");
+ assertAnnotationCompletions();
+ }
+
+ private void prepareCase(String selectedAnnotation, String annotationStatementBeforeTest) throws Exception {
+ InputStream resource = this.getClass().getResourceAsStream("/test-projects/test-scope-annotation/src/main/java/org/test/TestScopeCompletion.java");
+ String content = IOUtils.toString(resource);
+
+ content = content.replace(selectedAnnotation, annotationStatementBeforeTest);
+ editor = new Editor(harness, content, "java");
+ }
+
+ private void assertAnnotationCompletions(String... completedAnnotations) throws Exception {
+ List completions = editor.getCompletions();
+ int i = 0;
+ for (String expectedCompleted : completedAnnotations) {
+ Editor clonedEditor = editor.clone();
+ clonedEditor.apply(completions.get(i++));
+ assertTrue(clonedEditor.getText().contains(expectedCompleted));
+ }
+
+ assertEquals(i, completions.size());
+ }
+
+
+}
diff --git a/vscode-extensions/vscode-boot-java/src/test/java/org/springframework/ide/vscode/project/harness/ProjectsHarness.java b/vscode-extensions/vscode-boot-java/src/test/java/org/springframework/ide/vscode/project/harness/ProjectsHarness.java
new file mode 100644
index 000000000..7f56c7744
--- /dev/null
+++ b/vscode-extensions/vscode-boot-java/src/test/java/org/springframework/ide/vscode/project/harness/ProjectsHarness.java
@@ -0,0 +1,162 @@
+/*******************************************************************************
+ * Copyright (c) 2016 Pivotal, Inc.
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ * Pivotal, Inc. - initial API and implementation
+ *******************************************************************************/
+package org.springframework.ide.vscode.project.harness;
+
+import java.io.IOException;
+import java.net.URI;
+import java.net.URISyntaxException;
+import java.nio.file.Path;
+import java.nio.file.Paths;
+
+import org.springframework.ide.vscode.commons.java.IJavaProject;
+import org.springframework.ide.vscode.commons.maven.MavenBuilder;
+import org.springframework.ide.vscode.commons.maven.MavenCore;
+import org.springframework.ide.vscode.commons.maven.java.MavenJavaProject;
+import org.springframework.ide.vscode.commons.maven.java.classpathfile.JavaProjectWithClasspathFile;
+
+import com.google.common.cache.Cache;
+import com.google.common.cache.CacheBuilder;
+
+/**
+ * Test projects harness
+ *
+ * @author Alex Boyko
+ *
+ */
+public class ProjectsHarness {
+
+ public static final ProjectsHarness INSTANCE = new ProjectsHarness();;
+
+ public Cache cache = CacheBuilder.newBuilder().concurrencyLevel(1).build();
+
+ private enum ProjectType {
+ MAVEN,
+ CLASSPATH_TXT
+ }
+
+ private ProjectsHarness() {
+ }
+
+ public IJavaProject project(ProjectType type, String name) throws Exception {
+ return cache.get(type + "/" + name, () -> {
+ Path testProjectPath = getProjectPath(name);
+ switch (type) {
+ case MAVEN:
+ MavenBuilder.newBuilder(testProjectPath).clean().pack().javadoc().skipTests().execute();
+ return new MavenJavaProject(testProjectPath.resolve(MavenCore.POM_XML).toFile());
+ case CLASSPATH_TXT:
+ MavenBuilder.newBuilder(testProjectPath).clean().pack().skipTests().execute();
+ return new JavaProjectWithClasspathFile(testProjectPath.resolve(MavenCore.CLASSPATH_TXT).toFile());
+ default:
+ throw new IllegalStateException("Bug!!! Missing case");
+ }
+ });
+ }
+
+ protected Path getProjectPath(String name) throws URISyntaxException, IOException {
+// URI sourceLocation = ProjectsHarness.class.getProtectionDomain().getCodeSource().getLocation().toURI();
+// // file:/Users/aboyko/git/sts4/vscode-extensions/commons/project-test-harness/target/project-test-harness-0.0.1-SNAPSHOT.jar
+// Path testProjectsPath = Paths.get(sourceLocation).getParent().getParent().resolve("test-projects").resolve(name);
+// if (Files.exists(testProjectsPath)) {
+// return testProjectsPath;
+// } else {
+// /*
+// * If "test-projects" folder is not found then extract test project
+// * from the jar's "test-projects" folder and copy it in the temp
+// * folder
+// */
+ return getProjectPathFromClasspath(name);
+// }
+ }
+
+ private Path getProjectPathFromClasspath(String name) throws URISyntaxException, IOException {
+ URI resource = ProjectsHarness.class.getResource("/test-projects/" + name).toURI();
+// if (resource.getScheme().equalsIgnoreCase("jar")) {
+// return getProjectPathFromJar(resource);
+// } else {
+ return Paths.get(resource);
+// }
+ }
+
+// private Path getProjectPathFromJar(URI jar) throws IOException {
+// final String[] array = jar.toString().split("!");
+// URI firstHalf = URI.create(array[0]);
+// Path tempFolderPath = Paths.get(new File(System.getProperty(MavenCore.JAVA_IO_TMPDIR)).toURI());
+// FileSystem fs = FileSystems.newFileSystem(firstHalf, Collections.emptyMap());
+// try {
+// Path path = fs.getPath(array[1]);
+// Path projectCopyPath = tempFolderPath.resolve(path.getFileName().toString());
+// if (Files.exists(projectCopyPath)) {
+// recursiveDelete(projectCopyPath);
+// }
+// recursiveCopy(path, tempFolderPath, StandardCopyOption.REPLACE_EXISTING);
+// System.out.println("Copied test project to: " + projectCopyPath);
+// return projectCopyPath;
+// } finally {
+// fs.close();
+// }
+// }
+//
+// private static void recursiveCopy(Path source, Path target, CopyOption... options) throws IOException {
+// Files.walkFileTree(source, new SimpleFileVisitor() {
+//
+// Path destination = target;
+//
+// @Override
+// public FileVisitResult preVisitDirectory(Path dir, BasicFileAttributes attrs) throws IOException {
+// destination = destination.resolve(dir.getFileName().toString());
+// Files.copy(dir, destination, options);
+// return super.preVisitDirectory(dir, attrs);
+// }
+//
+// @Override
+// public FileVisitResult visitFile(Path file, BasicFileAttributes attrs) throws IOException {
+// Path newFile = destination.resolve(file.getFileName().toString());
+// Files.copy(file, newFile, options);
+// return super.visitFile(file, attrs);
+// }
+//
+// @Override
+// public FileVisitResult postVisitDirectory(Path dir, IOException exc) throws IOException {
+// destination = destination.getParent();
+// return super.postVisitDirectory(dir, exc);
+// }
+//
+// });
+// }
+//
+// private static void recursiveDelete(Path path) throws IOException {
+// Files.walkFileTree(path, new SimpleFileVisitor() {
+//
+// @Override
+// public FileVisitResult visitFile(Path file, BasicFileAttributes attrs) throws IOException {
+// Files.delete(file);
+// return super.visitFile(file, attrs);
+// }
+//
+// @Override
+// public FileVisitResult postVisitDirectory(Path dir, IOException exc) throws IOException {
+// Files.delete(dir);
+// return super.postVisitDirectory(dir, exc);
+// }
+//
+// });
+// }
+
+ public MavenJavaProject mavenProject(String name) throws Exception {
+ return (MavenJavaProject) project(ProjectType.MAVEN, name);
+ }
+
+ public IJavaProject javaProjectWithClasspathFile(String name) throws Exception {
+ return project(ProjectType.CLASSPATH_TXT, name);
+ }
+
+}
diff --git a/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/.gitignore b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/.gitignore
new file mode 100644
index 000000000..2af7cefb0
--- /dev/null
+++ b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/.gitignore
@@ -0,0 +1,24 @@
+target/
+!.mvn/wrapper/maven-wrapper.jar
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+nbproject/private/
+build/
+nbbuild/
+dist/
+nbdist/
+.nb-gradle/
\ No newline at end of file
diff --git a/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/.mvn/wrapper/maven-wrapper.jar b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 000000000..5fd4d5023
Binary files /dev/null and b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/.mvn/wrapper/maven-wrapper.properties b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 000000000..c954cec91
--- /dev/null
+++ b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1 @@
+distributionUrl=https://repo1.maven.org/maven2/org/apache/maven/apache-maven/3.3.9/apache-maven-3.3.9-bin.zip
diff --git a/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/mvnw b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/mvnw
new file mode 100755
index 000000000..a1ba1bf55
--- /dev/null
+++ b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/mvnw
@@ -0,0 +1,233 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven2 Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ #
+ # Look for the Apple JDKs first to preserve the existing behaviour, and then look
+ # for the new JDKs provided by Oracle.
+ #
+ if [ -z "$JAVA_HOME" ] && [ -L /System/Library/Frameworks/JavaVM.framework/Versions/CurrentJDK ] ; then
+ #
+ # Apple JDKs
+ #
+ export JAVA_HOME=/System/Library/Frameworks/JavaVM.framework/Versions/CurrentJDK/Home
+ fi
+
+ if [ -z "$JAVA_HOME" ] && [ -L /System/Library/Java/JavaVirtualMachines/CurrentJDK ] ; then
+ #
+ # Apple JDKs
+ #
+ export JAVA_HOME=/System/Library/Java/JavaVirtualMachines/CurrentJDK/Contents/Home
+ fi
+
+ if [ -z "$JAVA_HOME" ] && [ -L "/Library/Java/JavaVirtualMachines/CurrentJDK" ] ; then
+ #
+ # Oracle JDKs
+ #
+ export JAVA_HOME=/Library/Java/JavaVirtualMachines/CurrentJDK/Contents/Home
+ fi
+
+ if [ -z "$JAVA_HOME" ] && [ -x "/usr/libexec/java_home" ]; then
+ #
+ # Apple JDKs
+ #
+ export JAVA_HOME=`/usr/libexec/java_home`
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Migwn, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+ # TODO classpath?
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`which java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+fi
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+ local basedir=$(pwd)
+ local wdir=$(pwd)
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ wdir=$(cd "$wdir/.."; pwd)
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-$(find_maven_basedir)}
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} "$@"
diff --git a/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/mvnw.cmd b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/mvnw.cmd
new file mode 100644
index 000000000..2b934e89d
--- /dev/null
+++ b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/mvnw.cmd
@@ -0,0 +1,145 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM http://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven2 Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a key stroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM enable echoing my setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+set MAVEN_CMD_LINE_ARGS=%*
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+
+set WRAPPER_JAR="".\.mvn\wrapper\maven-wrapper.jar""
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CMD_LINE_ARGS%
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
+
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
+
+exit /B %ERROR_CODE%
\ No newline at end of file
diff --git a/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/pom.xml b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/pom.xml
new file mode 100644
index 000000000..7fe1c3c40
--- /dev/null
+++ b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/pom.xml
@@ -0,0 +1,43 @@
+
+
+ 4.0.0
+
+ com.example
+ test-scope-annotation
+ 0.0.1-SNAPSHOT
+ jar
+
+ test-scope-annotation
+ Test projects for spring boot java language server - scope annotations
+
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 1.4.3.RELEASE
+
+
+
+
+ UTF-8
+ UTF-8
+ 1.8
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+
+
diff --git a/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/src/main/java/org/test/TestScopeAnnotationApplication.java b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/src/main/java/org/test/TestScopeAnnotationApplication.java
new file mode 100644
index 000000000..90fb713da
--- /dev/null
+++ b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/src/main/java/org/test/TestScopeAnnotationApplication.java
@@ -0,0 +1,12 @@
+package org.test;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+
+@SpringBootApplication
+public class TestScopeAnnotationApplication {
+
+ public static void main(String[] args) {
+ SpringApplication.run(TestScopeAnnotationApplication.class, args);
+ }
+}
diff --git a/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/src/main/java/org/test/TestScopeCompletion.java b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/src/main/java/org/test/TestScopeCompletion.java
new file mode 100644
index 000000000..3f858ac03
--- /dev/null
+++ b/vscode-extensions/vscode-boot-java/src/test/resources/test-projects/test-scope-annotation/src/main/java/org/test/TestScopeCompletion.java
@@ -0,0 +1,14 @@
+package org.test;
+
+import org.springframework.context.annotation.Bean;
+import org.springframework.context.annotation.Scope;
+
+@Scope("onClass")
+public class TestScopeCompletion {
+
+ @Bean
+ @Scope("onMethod")
+ public Object myBean() {
+ return null;
+ }
+}
diff --git a/vscode-extensions/vscode-boot-properties/src/test/java/org/springframework/ide/vscode/boot/test/ApplicationPropertiesEditorTest.java b/vscode-extensions/vscode-boot-properties/src/test/java/org/springframework/ide/vscode/boot/test/ApplicationPropertiesEditorTest.java
index 025fa51b8..5ea78f46f 100644
--- a/vscode-extensions/vscode-boot-properties/src/test/java/org/springframework/ide/vscode/boot/test/ApplicationPropertiesEditorTest.java
+++ b/vscode-extensions/vscode-boot-properties/src/test/java/org/springframework/ide/vscode/boot/test/ApplicationPropertiesEditorTest.java
@@ -42,13 +42,11 @@ import com.google.common.io.Files;
* Boot App Properties Editor tests
*
* @author Alex Boyko
- *
*/
public class ApplicationPropertiesEditorTest extends AbstractPropsEditorTest {
-
-
- @Test public void testReconcileCatchesParseError() throws Exception {
+ @Test
+ public void testReconcileCatchesParseError() throws Exception {
Editor editor = newEditor("key\n");
editor.assertProblems("key|extraneous input");
}